#!/bin/bash

set -e

products=(
	"0x15CF" "0x0019" "Avtor SecureToken"
	"0x15CF" "0x001D" "SC Reader 371"
)

list_locations=(
	"/etc/libccid_Info.plist"
	"/usr/lib/pcsc/drivers/ifd-ccid.bundle/Contents/Info.plist"
	"/usr/libexec/SmartCardServices/drivers/ifd-ccid.bundle/Contents/Info.plist"
)

#PCSCD_LAUNCH_FILE="/etc/init.d/pcscd"



testFile()
{
	if [ ! -f $1 ]; then
		return 1
	fi

	found=1
	for (( i=0; i \< $prodcount; i++ ))
	do
		present[i]="`grep -i "${products[i*3+2]}" "$1" | wc -l`"
		if [ 0 = ${present[i]} ]; then
			found=0
		fi
	done
	
	return $found
}

echoMissing()
{
	for (( i=0; i \< $prodcount; i++ )); do
		if [ 0 = ${present[i]} ]; then
			echo -e "\t\t<string>${products[i*3+$1]}</string>"
		fi
	done
}

addReaders()
{
	IFS=''
	mode=
	while read -r line; do
		if [[ "$line" =~ \<key\>.*ifdVendorID.*\</key\> ]]; then
			mode=v
		elif [[ "$line" =~ \<key\>.*ifdProductID.*\</key\> ]]; then
			mode=d
		elif [[ "$line" =~ \<key\>.*ifdFriendlyName.*\</key\> ]]; then
			mode=t
		elif [[ "$line" =~ \<array\> ]]; then
			mode="${mode}a"
		elif [[ "$line" =~ \</array\> ]]; then
			case $mode in
			va)
				echoMissing 0
				;;
			da)
				echoMissing 1
				;;
			ta)
				echoMissing 2
				;;
			esac
			mode=
		fi
		echo "$line"
	done
}

filter_exit()
{
	IFS=''
	mode=0
	while read -r line; do
		if [ $mode = 0 ]; then
			if [[ "$line" =~ "DO NOT start the daemon on startup" ]]; then
				mode=1
			fi
		else
			if [[ "$line" =~ ^[\ \	]*exit[\ \	]*0[\ \	]*$ ]]; then
				echo "# $line"
				continue
			elif [[ ! "$line" =~ ^[\ \	]*(#.*)?$ ]]; then
				mode=0
			fi
		fi
		echo "$line"
	done
}



# Adding readers to the list...
prodcount=${#products[@]}
let prodcount/=3

result=1
for list_file in "${list_locations[@]}"; do
	if [ -f "$list_file" ]; then
		result=0
	fi

	if testFile "$list_file"; then
		addReaders < "$list_file" > "${list_file}_tmp"
		mv -f "${list_file}_tmp" "$list_file"
	fi
done

# Enabling pcscd autostart...
#if [ -f "$PCSCD_LAUNCH_FILE" ]; then
#	filter_exit < "$PCSCD_LAUNCH_FILE" > "${PCSCD_LAUNCH_FILE}_tmp"
#	mv -f "${PCSCD_LAUNCH_FILE}_tmp" "$PCSCD_LAUNCH_FILE"
#	chmod +x "$PCSCD_LAUNCH_FILE"
#fi

# Restarting daemons...
set +e
service udev restart
#service pcscd restart

exit $result
